package cz.cvut.fel.pjv;

public class CircularQueue {
  private int[] array;
  int capacity, front, rear, count;

  public CircularQueue(int capacity) {
    this.capacity = capacity;
    array = new int[capacity];
    front = 0;
    rear = 0;
    count = 0;
  }
  
  public void push(int element) throws CircularQueueFullException {
    if (isFull()) {
      throw new CircularQueueFullException("ERROR: CircularQueue is full");
    }
    array[rear] = element;
    rear = rear++ % capacity;
    count++;
  }
  
  public int pop() throws CircularQueueEmptyException {
    if (isEmpty()) {
      throw new CircularQueueEmptyException("ERROR: CircularQueue is empty");
    }
    int element = array[front];
    front = front++ % capacity;
    count--;
    return element;
  }
  
  public boolean isEmpty() {
    return count == 0;
  }

  public boolean isFull() {
    return count == capacity;
  }
}
